<script lang="ts" setup>
import { useBookingStore } from '@/stores/booking';
import { useRoomStore } from '@/stores/room';
import { storeToRefs } from 'pinia';
import { onMounted, ref } from 'vue';
import WeekPlanning from '../components/WeekPlanning.vue';
import MonthPlanning from '../components/monthPlanning/MonthPlanning.vue';
import { usePromoStore } from '@/stores/promo';
import DayPlanning from '@/components/DayPlanning.vue';
import type { Booking, Room } from '@/entities';
import ModalBooking from '@/components/ModalBooking.vue';
import { useAuthStore } from '@/stores/auth';
import dayjs, { Dayjs } from 'dayjs';

const storeAuth = useAuthStore();
const {token} = storeToRefs(storeAuth);

const storeRoom = useRoomStore();

const storePromo = usePromoStore();

const storeBooking = useBookingStore();
const { bookings } = storeToRefs(storeBooking)

const startDate = ref<Dayjs>(dayjs());
const lastFetch = ref<Dayjs>(dayjs());

const selectedBooking = ref<Booking>();

// swith composants day/week/month
const selectedComponent = ref("day");


/**
 * fetch back-end with first day of month - 10 // last day of month +10
 */
function fetchBookingsByMonth() {
  lastFetch.value = startDate.value.clone();
  storeBooking.fetchBookings(startDate.value.startOf('month').subtract(10,'d').toDate(), 
                              startDate.value.endOf('month').add(10,'d').toDate());
}

/**
 * add days to startDate
 * fetch server if month change
 */
function addDays(days: number) {
  startDate.value = startDate.value.add(days, 'days');
  if (startDate.value.month() != lastFetch.value.month() && (startDate.value.date() > 10 && startDate.value.date() < 20)) {
    fetchBookingsByMonth();
  }
}

function handleSelect(booking?:Booking) {
  if(!token.value) {
    return;
  }
  selectedBooking.value = booking;
}

function selectComponent(comp: string) {
  switch (comp) {
    case "day":
      selectedComponent.value = "day"
      break;
    case "week":
      selectedComponent.value = "week"
      break;
    case "month":
      selectedComponent.value = "month"
      break;
  }
}

/**
 * return to today
 */
function getToday() {
  startDate.value = dayjs().hour(8);
  addDays(0);
}


onMounted(() => {
  storeRoom.fetchRooms();
  fetchBookingsByMonth();
  storePromo.fetchPromos();
});


</script>
  
  
<template>
  <header>

    <div>
      <el-menu :default-active="selectedComponent" mode="horizontal" :router="false">

        <el-menu-item @click="selectComponent('day')">Tri par jour</el-menu-item>
        <el-menu-item @click="selectComponent('week')">Tri par semaine</el-menu-item>
        <el-menu-item @click="selectComponent('month')">tri par mois</el-menu-item>

      </el-menu>

    </div>
  </header>

  <ModalBooking v-if="selectedBooking" :with-button="false" :booking="selectedBooking" 
  @modal-closed="handleSelect(undefined)"/>
  
  <DayPlanning v-if="selectedComponent === 'day'" :switchable="true" :date="startDate" :bookings="bookings.filter(item => startDate.isAfter(item.startDate) && startDate.isBefore(item.endDate))"
  @changeDay="addDays" @date-select="handleSelect" />

  <WeekPlanning v-if="selectedComponent === 'week'" :day="startDate"
    @changeWeek="addDays" @date-select="handleSelect"  />

  <MonthPlanning v-if="selectedComponent === 'month'" :day="startDate" :bookings="bookings"
    @changeMonth="addDays" @get-today="getToday" @date-select="handleSelect" />
</template>